#include <string.h>
#include "yatable_keyinfo.h"
#include "keyname-table.h"
#include "modkey-table.h"

unsigned int YaTableKeyNameGetKeyCode(const char* KeyName)
{
    const gdk_key* entry = gdk_keys_by_keyval;
    const char* keyname = keynames;

    while(entry->keyval != XK_VoidSymbol) {
        if(strcmp(keyname + entry->offset, KeyName) == 0)
            return entry->keyval;
        entry ++;
    }
    return XK_VoidSymbol;
}

const char* YaTableKeyCodeGetKeyName(unsigned int KeyCode)
{
    const gdk_key* entry = gdk_keys_by_keyval;
    const char* keyname = keynames;

    while(entry->keyval != XK_VoidSymbol) {
        if(entry->keyval == KeyCode)
            return keyname + entry->offset;
        entry ++;
    }
    return NULL;
}

unsigned int YaTableKeyNameGetModState(const char* KeyName)
{
    const gdk_mod_key* entry = gdk_mod_keys;

    size_t count = sizeof(gdk_mod_keys) / sizeof(gdk_mod_key);
    size_t i = 0;
    while(i < count) {
        if(strcmp((entry + i)->keyname, KeyName) == 0)
            return (entry + i)->modstat;
        i++;
    }

    return 0;
}

const char* YaTableModStateGetKeyName(unsigned int ModState)
{
    const gdk_mod_key* entry = gdk_mod_keys;

    size_t count = sizeof(gdk_mod_keys) / sizeof(gdk_mod_key);
    size_t i = 0;
    while(i < count) {
        if((entry + i)->modstat == ModState)
            return (entry + i)->keyname;
        i++;
    }

    return NULL;
}

